unit Oszi2;

interface

uses EZUSB,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    Messung: TButton;
    Save: TButton;
    ScrollBar1: TScrollBar;
    Button1: TButton;
    Timer1: TTimer;
    Button2: TButton;
    procedure MessungClick(Sender: TObject);
    procedure Messung2Click(Sender: TObject);
    procedure SaveClick(Sender: TObject);
    procedure ClearClick(Sender: TObject);
    procedure PaintBox1Click(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  end;

var
  Form1: TForm1;
  Buffer : Array [0..8000] of Byte;
 
implementation

{$R *.DFM}



procedure SaveData (Dateiname :String);
var  f : Text;
     n, r : Integer;
begin
  AssignFile(f,dateiname);
  {$I-} ReWrite(f); {$I+}
  r := IOresult;
  if  r = 0 then begin
     for n:=0 to 1023 do begin;
        writeln (f,Buffer [n]);
     end;
     CloseFile (f);
  end;
end;

procedure DiagrammInit;
var n: Integer;
begin
  with Form1.Paintbox1.Canvas do begin
  Pen.Color:=ClBlack;
  Brush.Color:=ClWhite;
  Rectangle(30,0,531,257);
  Pen.Color:=ClLtGray;
  for n:= 1 to 8 do begin
      MoveTo(31,256-n*31);
      Lineto (529,256-n*31);
  end;
  Brush.Color:=ClLtGray;
  for n:= 0 to 4 do begin
    TextOut(10,250-n*62,FloatToStr(n)+' V');
  end;
  for n:= 1 to 9 do begin
      MoveTo(30+50*n,254);
      Lineto (30+50*n,0)
  end;
  for n:= 1 to 10 do begin
    TextOut(15+50*n,260,FloatToStr(n*5)+'ms');
  end;
  end;
end;

procedure Plot (Kanal: Integer);
var i: Integer;
begin
  with Form1.Paintbox1.Canvas do begin
    Pen.Color:=ClBlack;
    MoveTo (31,256-Buffer[0]);
    for i := 1 to 499 do
      LineTo (31+i ,256-Buffer[i]);
  end;
end;

procedure TForm1.MessungClick(Sender: TObject);
var n,i: Word;
begin
  ProgReset;
  DiagrammInit;
  ProgStart;
  Sleep (100);
  ProgReset;
  for n:= 0 to 3 do begin
    ReadRamBytes ((512+n*1024),1024);
    for i:= 0 to 1023 do Buffer[n*1024+i] := InBuffer[i];
  end;
  Plot (0)

end;


procedure TForm1.Messung2Click(Sender: TObject);
begin
  DiagrammInit;
end;

procedure TForm1.SaveClick(Sender: TObject);
begin
  SaveData('Output.dat');
end;

procedure TForm1.ClearClick(Sender: TObject);
begin
  DiagrammInit;
end;

procedure TForm1.PaintBox1Click(Sender: TObject);
begin
DiagrammInit;
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
  WrRAM ($01FF,255-Scrollbar1.Position);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ProgReset;
  DownLoadBin ('MAX186_d.obj');
  WrRAM ($01FF,127); //Trigger = 127
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Timer1.Enabled := true;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var n,i: Word;
begin
  ProgReset;
  DiagrammInit;
  ProgStart;
  Sleep (200);
  ProgReset;
  for n:= 0 to 3 do begin
    ReadRamBytes ((512+n*1024),1024);
    for i:= 0 to 1023 do Buffer[n*1024+i] := InBuffer[i];
  end;
  Plot (0)
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Timer1.Enabled := false;
end;

end.

