;I2CEE_A.asm
;Read EEPROM 24C00
;I2C Adr 1FDh
:Adr/Dat 1FFh/200h...2FFh

#include 8051.h
OEA  .equ   7F9Ch
OEB  .equ   7F9Dh
OEC  .equ   7F9Eh
PINSA .equ  7F99h
PINSB .equ  7F9Ah
PINSC .equ  7F9Bh
OUTA .equ   7F96h
OUTB .equ   7F97h
OUTC .equ   7F98h
I2CS  .equ  7FA5h
I2DAT .equ  7FA6h
START .equ  80h
STOP  .equ  40h
LASTRD .equ 20h
ACK   .equ  02h
DONE  .equ  01h
DPS  .equ   86h

initPortC
     mov DPTR,#OEC
     mov A,#255
     movx @DPTR,A

I2COut
     mov   DPTR,#I2CS
     mov   a,#START
     movx  @DPTR,a
     mov   DPTR,#01FDh ;I2C write address
     movx  a,@DPTR    
     mov   DPTR,#I2DAT
     movx  @DPTR,a
     lcall Ready
     mov   DPTR,#01FFh
     movx  a,@DPTR    ;start address
     mov   DPTR,#I2DAT
     movx  @DPTR,a    ;write data
     lcall Ready
     mov   DPTR,#I2CS
     mov   a,#STOP
     movx  @DPTR,a
     lcall Ready
     lcall Delay

I2CIn
     mov DPS,#1  	;select DPTR1
     mov DPTR,#200h     ;RAM data
     mov DPS,#0  	;select DPTR0

     mov   DPTR,#I2CS
     mov   a,#START
     movx  @DPTR,a
     mov   DPTR,#01FDh  ;I2C address
     movx  a,@DPTR    
     inc   a            ;read address
     mov   DPTR,#I2DAT
     movx  @DPTR,a
     lcall Ready
     mov   DPTR,#I2DAT
     movx  a,@DPTR      ;dummy byte
     lcall Ready

     mov   r7,#00h
Loop
     mov   DPTR,#I2DAT
     movx  a,@DPTR      ;data byte
     inc   DPS
     movx  @DPTR,a      ;save data
     inc   DPTR
     inc   DPS
     lcall Ready
     djnz  r7,Loop      ;256 bytes
     mov   DPTR,#I2CS
     mov   a,#LASTRD
     movx  @DPTR,a
     mov   DPTR,#I2DAT
     movx  a,@DPTR      ;dummy byte
     lcall Ready
     mov   DPTR,#I2CS
     mov   a,#STOP
     movx  @DPTR,a
     lcall Ready
     lcall Delay
End  sjmp  End

Ready
     mov   DPTR,#I2CS
     movx  a,@DPTR
     anl   a,#DONE
     cjne  a,#DONE,Ready 
     ret

Delay
     mov   r7,#4
S1   mov   r6,#100
S2   djnz  r6,S2
     djnz  r7,S1   
     ret 
.End
